
module.exports = {
	protocolVersion: "1",
	hostname: "http://www.google-analytics.com",
	path: "/collect",
	acceptedParameters: ["v","tid","aip","qt","z","cid","uid","sc","uip","ua","dr","cn","cs","cm","ck","cc","ci","gclid","dclid","sr","vp","de","sd","ul","je","fl","t","ni","dl","dh","dp","dt","cd","linkid","an","aid","av","aiid","ec","ea","el","ev","ti","ta","tr","ts","tt","in","ip","iq","ic","iv","cu","sn","sa","st","utc","utv","utt","utl","plt","dns","pdt","rrt","tcp","srt","exd","exf","xid","xvar"],
	customMetricRegex: /^cm[0-9]+$/,
	customDimensionRegex: /^cd[0-9]+$/,
	parametersMap: {
        "protocolVersion": "v",
        "trackingId": "tid",
        "webPropertyId": "tid",
        "anonymizeIp": "aip",
        "queueTime": "qt",
        "cacheBuster": "z",
        "clientId": "cid",
        "userId": "uid",
        "sessionControl": "sc",
        "ipOverride": "uip",
        "userAgentOverride": "ua",
        "documentReferrer": "dr",
        "campaignName": "cn",
        "campaignSource": "cs",
        "campaignMedium": "cm",
        "campaignKeyword": "ck",
        "campaignContent": "cc",
        "campaignId": "ci",
        "googleAdwordsId": "gclid",
        "googleDisplayAdsId": "dclid",
        "screenResolution": "sr",
        "viewportSize": "vp",
        "documentEncoding": "de",
        "screenColors": "sd",
        "userLanguage": "ul",
        "javaEnabled": "je",
        "flashVersion": "fl",
        "hitType": "t",
        "non-interactionHit": "ni",
        "documentLocationUrl": "dl",
        "documentHostName": "dh",
        "documentPath": "dp",
        "documentTitle": "dt",
        "screenName": "cd",
        "linkId": "linkid",
        "applicationName": "an",
        "applicationId": "aid",
        "applicationVersion": "av",
        "applicationInstallerId": "aiid",
        "eventCategory": "ec",
        "eventAction": "ea",
        "eventLabel": "el",
        "eventValue": "ev",
        "transactionId": "ti",
        "transactionAffiliation": "ta",
        "transactionRevenue": "tr",
        "transactionShipping": "ts",
        "transactionTax": "tt",
        "itemName": "in",
        "itemPrice": "ip",
        "itemQuantity": "iq",
        "itemCode": "ic",
        "itemCategory": "iv",
        "currencyCode": "cu",
        "socialNetwork": "sn",
        "socialAction": "sa",
        "socialActionTarget": "st",
        "userTimingCategory": "utc",
        "userTimingVariableName": "utv",
        "userTimingTime": "utt",
        "userTimingLabel": "utl",
        "pageLoadTime": "plt",
        "dnsTime": "dns",
        "pageDownloadTime": "pdt",
        "redirectResponseTime": "rrt",
        "tcpConnectTime": "tcp",
        "serverResponseTime": "srt",
        "exceptionDescription": "exd",
        "isExceptionFatal?": "exf",
        "experimentId": "xid",
        "experimentVariant": "xvar"
    }
};
